#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "invsubs.h"

/* function to compute the tomography misfit */

float GetMisfit(float *s,int nCells, int nobs,float *obs)
{

  FILE *flofile, *intfile;
  int iobs, j, *indices, nnot_zero, r_error;
  float predicted, res, misfit, *l;


  l       = (float *) calloc(nCells, sizeof(float));
  indices = (int *)   calloc(nCells, sizeof(int));

  /*************************************************************************************************/
  /* OPEN the PATH FILES */
  /*************************************************************************************************/

  intfile = fopen("L_indices", "r");
  if (intfile == NULL) {
    fprintf(stderr, "Problem opening the path index file.\n");
    exit(-1);
  }
  flofile = fopen("L_floats", "r");
  if (flofile == NULL) {
    fprintf(stderr, "Problem opening the path float file.\n");
    exit(-1);
  }

  /*************************************************************************************************/
  /* compute the predictions - loop over rows in path matrix */
  /*************************************************************************************************/

  misfit = 0.0;
  for (iobs = 0; iobs < nobs; iobs++) {

    GetRowValues(intfile, flofile, &l[0], &indices[0], &nnot_zero, &r_error);
    if (r_error == -1)
      fprintf(stdout, "Problem reading in row values: iobs=%d\n", iobs);

    /* compute the predicted time */
    predicted = 0;
    for (j = 0; j < nnot_zero; j++) {
      predicted += l[j] * s[indices[j]];
    }
    /* compute the residual */
    res = obs[iobs] - predicted;
    /* compute the misfit */
    misfit += res*res;

  }
  /* close the file */
  fclose(intfile);
  fclose(flofile);

  return(misfit);

}
